"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const SectionBody_1 = require("./SectionBody");
const SectionFooter_1 = require("./SectionFooter");
const SectionHeader_1 = require("./SectionHeader");
const prompts_1 = require("./store/prompts");
const rules_1 = require("./store/rules");
async function default_1(rules, prompts, inquirer) {
    (0, rules_1.setRules)(rules);
    (0, prompts_1.setPromptConfig)(prompts);
    const questions = [
        ...(0, SectionHeader_1.getQuestions)(),
        ...(0, SectionBody_1.getQuestions)(),
        ...(0, SectionFooter_1.getQuestions)(),
    ];
    const answers = await inquirer.prompt(questions);
    const header = (0, SectionHeader_1.combineCommitMessage)(answers);
    const body = (0, SectionBody_1.combineCommitMessage)(answers);
    const footer = (0, SectionFooter_1.combineCommitMessage)(answers);
    return [header, body, footer].filter(Boolean).join('\n');
}
exports.default = default_1;
//# sourceMappingURL=Process.js.map